<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        :loading="isLoading"
        @click="handleAudit(1)"
        >通过
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        >驳回
      </el-button>

      <el-dropdown
        @command="(command) => handleCommand(command)"
        style="margin-left: 30px"
        v-if="taskDefinitionKey != 'deptLeaderApprove'"
      >
        <span class="el-dropdown-link"
          >更多<i class="el-icon-arrow-down el-icon--right"></i
        ></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
  </el-col>
</template>

<script>
  import outin from '@/api/warehouseManagement/outin';
  import { cancel } from '@/api/bpm/components/purchasingManage/outSourceSend';
  import { approveTaskWithVariables } from '@/api/bpm/task';

  // 流程实例的详情页，可用于审批
  export default {
    name: '',
    components: {
      //   Parser
    },
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        isLoading: false,
        form: {
          reason: ''
        }
      };
    },
    methods: {
      async handleAudit(status) {
        // console.log(status);
        // let storemanIds = '';
        // let permissionType = this.tabOptions.find(
        //   (item) => item.key == this.taskDefinitionKey
        // )?.permissionType;
        // if (this.taskDefinitionKey === 'deptLeaderApprove') {
        //   let arr = await this.getTableValue();
        //   let ids = arr.productList.map((item) => item.warehouseId);
        //   let data = await getWarehouseListByIds(ids || []);
        //   storemanIds = [...new Set(data.map((item) => item.ownerId))].join(
        //     ','
        //   );
        // }
        if (!this.form.reason && !!status) {
          this.$message.error('请输入审批意见');
          return false;
        }
        if (this.taskDefinitionKey === 'storeman') {
          let data = await this.getTableValue();
          let storageData = data.returnStorageData;
          // 入库来源storageSource 0-正常  1-外部(外部跳过内部审核流程)
          storageData.storageSource = 1;
          console.log(storageData);
          try {
            this.isLoading = true;
            const res = await outin.saveNew(storageData);
            if (res.code == 0) {
              approveTaskWithVariables({
                id: this.taskId,
                reason: this.form.reason,
                variables: {
                  pass: !!status
                }
              }).then((res) => {
                if (res.code != '-1') {
                  this.$emit('handleAudit', {
                    status: status,
                    title: !status ? '驳回' : ''
                  });
                }
                this.isLoading = false;
              });
            }
          } catch (error) {
            this.isLoading = false;
            console.error('保存失败：', error);
          }
        } else {
          // await this._approveTaskWithVariables(status, storemanIds);
          await this._approveTaskWithVariables(status);
        }
      },
      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      },
      async _approveTaskWithVariables(status, storemanIds) {
        let variables = {
          pass: !!status
        };
        approveTaskWithVariables({
          id: this.taskId,
          reason: this.form.reason,
          variables
        }).then((res) => {
          if (res.data.code != '-1') {
            this.$emit('handleAudit', {
              status,
              title: status === 0 ? '驳回' : ''
            });
          }
        });
      },
      //更多
      handleCommand(command) {
        if (command === 'cancel') {
          this.$confirm('是否确认作废？', {
            type: 'warning',
            cancelButtonText: '取消',
            confirmButtonText: '确定'
          })
            .then(() => {
              cancel({
                id: this.taskId,
                reason: this.form.reason,
                businessId: this.businessId
              })
                .then(() => {
                  this.$emit('handleClose');
                })
                .catch(() => {
                  this.$message.error('流程作废失败');
                });
            })
            .catch(() => {});
        }
      }
    }
  };
</script>

<style lang="scss"></style>
